/*
 *  phonebook.h
 *
 *  Copyright(C) 2007,2008 Ixonos Plc
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Boston, MA 02111.
 */

/*
 * Written by
 *   Jukka Honkela
 *   Yi Zheng
 *   Matti Katila
 *   Vesa Pikki
 *   Heikki Paajanen
 */

#include "modem.h"
#include "phonebook_interface.h"

void gsmd_phonebook_init(ModemInterface *modem);
void gsmd_phonebook_deinitialize(ModemInterface *modem);

#define GSMD_PHONEBOOK_KEY_STORAGE_SPACES "storage_spaces"
#define GSMD_PHONEBOOK_KEY_LOWEST_INDEX "lowest_index"
#define GSMD_PHONEBOOK_KEY_HIGHEST_INDEX "highest_index"
#define GSMD_PHONEBOOK_KEY_DEFAULT_STORAGE_SPACE "default_storage_space"

AtCommandHandlerStatus gsmd_phonebook_handler_get_storage_spaces(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);

AtCommandHandlerStatus gsmd_phonebook_handler_get_default_storage_space(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);

AtCommandHandlerStatus gsmd_phonebook_handler_set_default_storage_space(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);

AtCommandHandlerStatus gsmd_phonebook_handler_store_entry(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);

AtCommandHandlerStatus gsmd_phonebook_handler_delete_entry(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);

AtCommandHandlerStatus gsmd_phonebook_handler_get_index_boundaries(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);

AtCommandHandlerStatus gsmd_phonebook_handler_retrieve_entry(
        ModemInterface *modem,
        AtCommandContext *at,
        GString *response);
