# Copyright(C) 2007,2008 Ixonos Plc
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Boston, MA 02111.

# Written by Matti Katila, Yi Zheng, Vesa Pikki and Heikki Paajanen

import unittest
from gsmd_common import GsmdCommon
import unittest, inspect,time

class CallTests(GsmdCommon):
    '''
    def test_Emergency(self):
        self.fail("Test not implemented yet!")
    def test_Emergency_Fail(self):
        self.fail("Test not implemented yet!")

    def test_SendDtmf(self):
        self.fail("Test not implemented yet!")
    def test_SendDtmf_Fail(self):
        self.fail("Test not implemented yet!")

    def test_GetStatus_Fail(self):
        self.fail("Test not implemented yet!")

    def test_SetDtmfDuration(self):
        self.fail("Test not implemented yet!")
    def test_SetDtmfDuration_Fail(self):
        self.fail("Test not implemented yet!")

    def test_GetDtmfDuration(self):
        self.fail("Test not implemented yet!")
    def test_GetDtmfDuration_Fail(self):
        self.fail("Test not implemented yet!")
    '''
    
    def check_call_status(self, index = 0, status = None,number = None):
        sig = self.ipc.WaitSignalValues("CallStatus",index)
        if status != None:
            assert sig[2] == status,"CallStatus signal's status is incorrect. Wanted "+str(status)+" got "+str(sig[2])
        if number != None:
            assert sig[3]['number'] == number,"CallStatus signal's number is incorrect. Wanted "+str(number)+" got "+str(sig[3]['number'])
            
    '''We have a depricated version of getstatus in gsmd2
    # TODO implement properly when we have call status handling
    def test_GetStatus(self):
        
        self.ipc.Call_GetStatus(0)
        data = [   ("ensure_reply", "Unknown"), #Dial returned 0
                   ("ensure_error", None), #Error wasn't returned by initiate method
                   ]
        self.perform(data)
    '''
    def incoming_call(self,number,index):
        data = [   ("write",'RING'),
                   ("write",'+CLIP: "'+str(number)+'",145,"",128,"",0'),
                   ("write",'#ECAM: '+str(index)+',6,1,,,'),
                   ("function",(self.check_call_status,index,"incoming",number)),
                   ("reset"),
                   ("write",'RING'),
                   ("write",'+CLIP: "'+str(number)+'",145,"",128,"",0'),
                   ("function",(self.check_call_status,index,"incoming",number)),
                   ]
        self.perform(data)

    def test_IncomingCall(self):
        self.incoming_call("+358405406978",0)
#        """Test that a incoming call signal is sent when gsmd2 receives a CLIP message."""

        '''
        data = [   ("write",'RING'),
                   ("write",'+CLIP: "+358405406978",145,"",128,"",0'),
                   ("write",'#ECAM: 0,6,1,,,'),
                   ("function",(self.check_call_status,0,"incoming",'+358405406978')),
                   ("reset"),
                   ("write",'RING'),
                   ("write",'+CLIP: "+358405406978",145,"",128,"",0'),
                   ("function",(self.check_call_status,0,"incoming",'+358405406978')),
                   ]
        self.perform(data)
        '''

    def test_Initiate(self):
#        """Test Dialing a call and making sure we get a 'connected' signal."""
        self.ipc.Call_Initiate("12345","")
        data = [   ("read","ATD12345;"),
                   ("write",'#ECAM: 0,1,1,,,"12345",129'),
                   ("function",(self.check_call_status,0,"outgoing")),
                   ("reset"),
                   ("write",'#ECAM: 0,2,1,,,'),
                   ("function",(self.check_call_status,0,"outgoing")),
                   ("reset"),
                   ("write",'OK'),
                   ("write",'#ECAM: 0,3,1,,,'),
                   ("ensure_reply_initiate"),
                   ("ensure_error_set",False), #Error wasn't returned by initiate method
                   ("function",(self.check_call_status,0,"active")),
                   ]
        self.perform(data)


    def test_Initiate_Fail(self):
#        """Test the fail cases of dialing."""
        messages = [('ERROR','Unknown'),
                    #('BUSY','Reject'), # not sure if this is correct
                    ('NO CARRIER','Disconnect')]
        #messages = [('ERROR','Unknown')]

        for err in messages:
            self.ipc.Reset()
            self.ipc.Call_Initiate("12345","")
            data = [   ("read","ATD12345;"),
                       ("write",err[0]),
                       ("ensure_error_set",True), #Error wasn't returned by initiate method
                       ]
            self.perform(data)
        print "Error messages done"
        # mine for timeout
        self.ipc.Reset()
        time.sleep(1)
        print "initiating a call"
        self.ipc.Call_Initiate("12345","")
        time.sleep(1)
        data = [   ("read","ATD12345;"),
                   ("write",'TIME_OUT'),
                   ("ensure_reply_set",False), #Dial method didn't return
                   ("ensure_error_set",True), #Error is set
                   ]
        self.perform(data)



    def test_Release_Fail(self):
#        """Test when hanging up an existing call fails."""
        self.test_Initiate()
        self.reset()
        self.ipc.Call_Release("",self.ipc.call_id)

        data = [    ("read","ATH"),
                    ("write","ERROR"),
                    ("reset"),
                    ("read","ATH"),
                    ("write","OK"),
                    ("ensure_reply_set",True),  #Reply is set
                    ("ensure_error_set",False),#error is not set
                    ("function",(self.check_call_status,0,"released")),
                    ]
        self.perform(data)
        time.sleep(2)



    def test_Release(self):
#        """Test hanging up an existing call."""
        self.test_Initiate()
        self.reset()
        self.ipc.Call_Release("",self.ipc.call_id)
        data = [   ("read","ATH"),
                   ("write","OK"),
                   ("ensure_error_set",False),       #error is not set
                   ("ensure_reply_set",True),   #call is set
                   ("function",(self.check_call_status,0,"released"))
                   ]
        self.perform(data)

    def test_RemoteHangup(self):
#        """Test how gsmd2 reacts when the remote end hangs up an existing call."""
        self.test_Accept()
        data = [   ("write",'#ECAM: 0,0,1,,,'),
                   ("write",'NO CARRIER'),
                   ("ensure_error_set",False),       #error is not set
                   ("function",(self.check_call_status,0,"released"))
                   ]
        self.perform(data)


    def test_Accept(self):
#        """Test accepting an incoming call."""
        self.test_IncomingCall()
        self.reset()
        self.ipc.Call_Activate(self.ipc.call_id);
        data = [("read","ATA"),
                   ("write","OK"),
                   ("ensure_error_set",False), #error is not set
                   ("ensure_reply_set",True), #dial is set
                   ("function",(self.check_call_status,0,"active"))
                   ]
        self.perform(data)

    def test_Accept_Fail(self):
#        """Test when accepting a call fails."""
        self.test_IncomingCall()
        self.ipc.Call_Activate(0);
        data = [   ("read","ATA"),
                        ("write",'ERROR'),
                        ("ensure_error_set",True), #error not set
                        ("ensure_reply_set",False)] #dial is not set
        self.perform(data)
    
    def test_ActivateWhileCalling(self):
        self.test_Accept()
        self.incoming_call("+358415406978",1)
        self.ipc.Call_Activate(1);
        data = [   ("reset"),
                        ("read","AT+CHLD=2"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,0,"held")),
                        ("function",(self.check_call_status,1,"active"))]
        self.perform(data)
        self.ipc.Call_Activate(0);
        data = [   ("reset"),
                        ("read","AT+CHLD=2"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,0,"active")),
                        ("function",(self.check_call_status,1,"held"))]
        self.perform(data)
    
    def test_ActivateConference(self):
        self.test_Accept()
        self.incoming_call("+358415406978",1)
        self.ipc.Call_ActivateConference(1);
        data = [   ("reset"),
                        ("read","AT+CHLD=3"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,1,"active"))]
        self.perform(data)
        self.incoming_call("+358425406978",2)
        self.ipc.Call_ActivateConference(2);
        data = [   ("reset"),
                        ("read","AT+CHLD=3"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,2,"active")),
                        ]
        self.perform(data)
        
    def test_ReleaseHeld(self):
        self.test_Accept()
        self.incoming_call("+358415406978",1)
        self.ipc.Call_ReleaseHeld("");
        data = [   ("reset"),
                        ("read","AT+CHLD=0"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,1,"released"))]
        self.perform(data)
        
    def test_ReleaseAll(self):
        self.test_Accept()
        self.incoming_call("+358415406978",1)
        self.ipc.Call_ActivateConference(1);
        data = [   ("reset"),
                        ("read","AT+CHLD=3"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,1,"active"))]
        self.perform(data)
        self.incoming_call("+358425406978",2)
        self.ipc.Call_ReleaseAll("");
        data = [   ("reset"),
                        ("read","AT+CHUP"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,0,"released")),
                        ("function",(self.check_call_status,1,"released")),
                        ("function",(self.check_call_status,2,"released")),
                        ]
        self.perform(data)
        
    def test_ActivateTwice(self):
        self.test_Accept()
        self.incoming_call("+358415406978",1)
        self.ipc.Call_Activate(1);
        data = [   ("reset"),
                        ("read","AT+CHLD=2"),
                        ("write",'OK'),
                        ("ensure_error_set",False), #error not set
                        ("ensure_reply_set",True),
                        ("function",(self.check_call_status,0,"held")),
                        ("function",(self.check_call_status,1,"active"))]
        self.perform(data)
        self.ipc.Call_Activate(1);
        data = [   ("ensure_error_set",False),("ensure_reply_set",True)]
        self.perform(data)
    

if __name__ == "__main__":
#    import os
#    os.spawnvpe(os.P_WAIT, "ls",("ls", "-l"), os.environ)
    try:
        unittest.main(testRunner=unittest.TextTestRunner(verbosity=2))
    except SystemExit:
        pass
    except:
        import traceback, sys
        traceback.print_exc(file=sys.stdout)
        import dbus_thread
        dbus_thread.stop_thread()
        sys.exit(1)
